--  _          _ _         _   _                     
-- | |__   ___| | | ___   | |_| |__   ___ _ __ ___   
-- | '_ \ / _ \ | |/ _ \  | __| '_ \ / _ \ '__/ _ \  
-- | | | |  __/ | | (_) | | |_| | | |  __/ | |  __/_ 
-- |_| |_|\___|_|_|\___/   \__|_| |_|\___|_|  \___(_)
--
-- This was Reusable, then it wasn't, then it was again.
-- Go nuts and do what you want, I've been away from v1 dev for way too long to be stingy.
--
-- HORNMOD was my first major project for Kart, and it's kicked off a wild period of my life, as corny as that sounds.
-- I've met a lot of new friends, I've learned a lot about disciplines that I love, and I get to appreciate cute robots.
-- It's been neat to come back to it and realize how much I've learned, and I hope the refinements are worth it.
--
-- Here's to Kart, which I'm convinced is unkillable at this point.
-- Happy honking. 
-- - Tyron, 2020-09-12
rawset(_G, "HORNMOD", "2")
print("\142HORNMOD *Championship Edition* v"..HORNMOD.." - a Tyron thing")
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MF2_SHADOW = MF2_SHADOW
local MF2_DONTDRAW = MF2_DONTDRAW
local k_eggmanexplode = k_eggmanexplode
local k_growshrinktimer = k_growshrinktimer
local k_invincibilitytimer = k_invincibilitytimer
local k_spinouttimer = k_spinouttimer
local k_itemtype = k_itemtype
local k_itemroulette = k_itemroulette
local k_itemheld = k_itemheld
local k_eggmanheld = k_eggmanheld
local k_rocketsneakertimer = k_rocketsneakertimer
local horn_debug = CV_RegisterVar({
	name = "horn_debug",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local horn_hellchance = CV_RegisterVar({
	name = "horn_hellchance",
	defaultvalue = "5",
	flags = CV_NETVAR,
	possiblevalue = CV_Unsigned
})
local horn_preferexpansions = CV_RegisterVar({
	name = "horn_preferexpansions",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local horn_antispam = CV_RegisterVar({
	name = "horn_explode",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local horn_volumelimit = CV_RegisterVar({
	name = "horn_volumelimit",
	defaultvalue = "10",
	flags = 0,
	possiblevalue = {MIN = 0, MAX = 255}
})
local horn_unleashhell = CV_RegisterVar({
	name = "horn_unleashhell",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL,
	possiblevalue = CV_OnOff,
	func = function()
		for p in players.iterate
			if p.hornmod and p.hornmod.selection then
				p.hornmod.selection = 0
				CONS_Printf(p, "Your horn was reset because the host changed settings.")
			end
			if p.hornmod and p.hornmod.faves then
				p.hornmod.faves = nil
				CONS_Printf(p, "Your faves were reset because the host changed settings.")
			end
		end
	end
})
local horn_truerandom = CV_RegisterVar({
	name = "horn_truerandom",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff,
})
local horn_ignorecountdown = CV_RegisterVar({
	name = "horn_ignorecountdown",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff,
})
local horns = {}
local hellhorns = {}
local muted = false
local baseonly = true
local hellbaseonly = true
rawset(_G, "HORNMOD_Horns", function()
	return horns
end)
rawset(_G, "HORNMOD_HellHorns", function()
	return hellhorns
end)
local function dprint(...)
	if not horn_debug.value then return end
	local fug = "\132[HORNMOD CE]\128 "
	if leveltime then fug = $ + "\132(" + leveltime + ")\128 " end
	if not ... then
		fug = $ + "Did you seriously pass NOTHING to a debug print?"
	else
		fug = $ + table.concat({...}, " ")
	end
	CONS_Printf(server, fug)
end
local starttime = 6 * TICRATE + (3 * TICRATE / 4)
freeslot("sfx_hmwarn")
freeslot("sfx_hmdang")
freeslot("sfx_hmslct")
freeslot("sfx_hmhell")
freeslot("sfx_hmstop") -- unused FOR NOW...
freeslot("MT_HAHALOUD")
freeslot("S_LOUD")
freeslot("SPR_HORN")
mobjinfo[MT_HAHALOUD] = {
	spawnstate = S_LOUD,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}
states[S_LOUD] = {
	sprite = SPR_HORN,
	frame = A
}
addHook("MobjThinker", function(mo)
	if not (mo.target and mo.target.valid and mo.target.player) then
		P_RemoveMobj(mo)
	end
end, MT_HAHALOUD)
local function playercount()
	local pnum = 0
	for p in players.iterate
		if p.spectator then continue end -- dont count specators
		pnum = $+1
	end
	return pnum
end
-- Okay, this is a little bit of a hack, but I came up with the schema while delirious from illness so I know it's a good idea.
-- Basically, filtering tables sucks, updating tables sucks, all that.
-- But because we have a limited number of places that actually need to set the horn, just faking the table size is somewhat sustainable.
-- If a horn index is past the maximum number of normal horns, it's a hell horn: for instance, with 200 base horns, horn #202 is hellhorn #2.
-- Here are a few wrappers that make this hack less stupid.
-- (I swear, it's actually less complicated and more performant than doing this "correctly"!)
local function hellcount()
	if horn_unleashhell.value then return #horns + #hellhorns end
	return #horns
end
local function hellref(x)
	if x > #horns then return hellhorns[x - #horns] end
	return horns[x]
end
local function prettyhornname(h)
	if h > #horns then
		return "\134#" .. h .. ": \133" .. hellref(h).info
	else
		return "\135#" .. h .. ": \130" .. hellref(h).info
	end
end
local function hornsoff(p, ...)
	p.hornmod = $ or {}
	p.hornmod.muted = true
	if p == consoleplayer then
		muted = true
	end
	CONS_Printf(p, "\131OK! \128You won't hear or send horns anymore. Try \130hornson\128 if you change your mind.")
end
COM_AddCommand("hornsoff", hornsoff)
local function hornsoff(p, ...)
	p.hornmod = $ or {}
	p.hornmod.muted = false
	if p == consoleplayer then
		muted = false
	end
	CONS_Printf(p, "\131OK! \128You will hear and send horns again. Welcome back!")
end
COM_AddCommand("hornson", hornsoff)
local function shutup(p, target) -- Significantly reduce horn annoyance from a target player.
	if p != consoleplayer then return end -- this should only run locally.
	if not target then
		CONS_Printf(p, "Specify a player who's bothering you, like \130shutup Tyron\128.")
		return
	end
	local acc = 0
	local loudidiot = nil
	if tonumber(target) != nil then
		loudidiot = players[tonumber(target)] -- thanks, terminal!
	else
		target = $:lower()
		for p in players.iterate
			if p.name:lower():match(target) then
				acc = $ + 1
				loudidiot = p
			end
		end
	end
	if loudidiot == nil then
		CONS_Printf(p, "No player matching that name / number exists, check your spelling?")
		return
	end
	if acc > 1 then
		CONS_Printf(p, "That matches more than one player. Be more specific!")
		return
	end
	if not loudidiot.hornmod.muffled then -- yeah the condition is backwards, what about it
		loudidiot.hornmod.muffled = true
		CONS_Printf(p, "\131OK! \128Horns from "..loudidiot.name.." will be way, way quieter.")
		CONS_Printf(p, "To undo this, just use the same command again.")
	else
		loudidiot.hornmod.muffled = false
		CONS_Printf(p, "\131OK! \128You will hear horns from "..loudidiot.name.." again.")
	end
end
COM_AddCommand("shutup", shutup)
local function hornlist(p, i)
	local guard = tonumber(i) or 1
	local rangehelp = ""
	local pagesize = 20
	local adjust = 0
	local total = hellcount()
	if total % pagesize then
		adjust = 1
	end
	if guard < 0 or guard > (total / pagesize + adjust) then
		guard = 1
		rangehelp = " \134(ignored your page number, out of range)"
	end
	local pagedivider = "\134=== Page \130" .. guard .. " \134of \130" .. (total/pagesize + adjust) .. " \134===" .. rangehelp
	guard = $ - 1
	local lowbound = guard * pagesize + 1
	local highbound = min(total, guard * pagesize + pagesize)
	CONS_Printf(p, pagedivider)
	for h = lowbound, highbound do
		CONS_Printf(p, prettyhornname(h))
	end
	CONS_Printf(p, pagedivider)
	CONS_Printf(p, "Try something like \135listhorns 3\128, \135sethorn 42\128 or \135sethorn galaga\128.")
end
COM_AddCommand("listhorns", hornlist)
local function sethorn(p, ...)
	p.hornmod = $ or {}
	local packedargs = {...}
	if #packedargs == 0 then
		CONS_Printf(p, "* \131(Trying \130listhorns\131...)")
		hornlist(p, 1)
		return
	end
	local guard = nil
	if #packedargs == 1 then
		guard = tonumber(packedargs[1])
	end
	if guard == nil or #packedargs > 1 then -- no direct number match, let's try a fuzzy search
		local searchstring = table.concat(packedargs, " "):lower()
		local hits = {}
		for k, v in ipairs(horns)
			if string.find(v.info:lower(), searchstring, 0, true) or (v.extags and string.find(v.extags:lower(), searchstring, 0, true)) then
				table.insert(hits, k)
			end
		end
		if horn_unleashhell.value then
			for k, v in ipairs(hellhorns) -- :GOD:
				if string.find(v.info:lower(), searchstring, 0, true) or (v.extags and string.find(v.extags:lower(), searchstring, 0, true)) then
					table.insert(hits, k + #horns)
				end
			end
		end
		if #hits > 1 then
			for k, v in ipairs(hits) do
				CONS_Printf(p, prettyhornname(v))
			end
			CONS_Printf(p, "\133Multiple horns match \135" .. searchstring .. "\133. \128Could you be more specific?")
			return
		elseif #hits == 0 then
			CONS_Printf(p, "\133No horns match \135" .. searchstring .. "\133. \128Check your spelling?")
			return
		else
			guard = hits[1]
		end
	end
	if guard == 0 then
		p.hornmod.selection = 0
		S_StartSound(nil, sfx_hmslct, p)
		CONS_Printf(p, "\131OK! \128Cleared your horn preference. Your next horn will be random.")
		return
	elseif guard < 1 or guard > hellcount() then
		CONS_Printf(p, "\133Out of range. \128Try a number between 1 and " .. hellcount() .. ", or use \135listhorns\128.")
		return
	end
	p.hornmod.selection = guard
	S_StartSound(nil, _G[hellref(guard).name], p)
	S_StartSound(nil, sfx_hmslct, p)
	CONS_Printf(p, "\131OK! \128Your horn will be " .. prettyhornname(guard) .. "\128 for the next race.\nUse \135resethorn\128 to return to random horns.")
end
COM_AddCommand("sethorn", sethorn)
-- helper provided for backcompat
local function resethorn(p, ...)
	sethorn(p, 0)
end
COM_AddCommand("resethorn", resethorn)
-- expert mode / horn testing
local function adjusthorn(p, target)
	p.hornmod = $ or {}
	if target == "random" then
		p.hornmod.selection = P_RandomRange(1, hellcount())
	else
		local guard = tonumber(target)
		if not guard or guard > #horns then
			CONS_Printf(p, "Why")
			return
		end
		if (not p.hornmod.selection) or p.hornmod.selection < 1 then
			p.hornmod.selection = 1
		else
			p.hornmod.selection = (($ + target + hellcount()) % hellcount()) or hellcount()
		end
	end
	S_StartSound(nil, _G[hellref(p.hornmod.selection).name], p)
	CONS_Printf(p, prettyhornname(p.hornmod.selection))
end
COM_AddCommand("adjusthorn", adjusthorn)
local function strsplit(s, delimiter)
    local result = {}
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match)
    end
    return result
end
-- helper provided for backcompat
local function favehorn(p, ...)
	p.hornmod = $ or {}
	local hm = p.hornmod
	local packedargs = {...}
	if #packedargs < 1 then
		CONS_Printf(p, "Specify multiple horn #s. While you don't have another horn set, you'll swap between them.\nExample: \130favehorn 11 28 35-39 53")
		CONS_Printf(p, "Use \130favehorn reset\128 to clear your favored horns and enable all loaded horns.")
		return
	end
	if #packedargs == 1 and (packedargs[1] == "0" or packedargs[1] == "reset") then
		CONS_Printf(p, "Cleared your favorite horns.")
		return
	end
	local tfaves = {}
	for i = 1, #packedargs
		local arg = packedargs[i]
		local guard = tonumber(arg)
		if guard then -- number
			if guard > hellcount() or guard < 1 then
				CONS_Printf(p, "Got confused when reading this segment (out of range): \130"..arg)
				return
			end
			table.insert(tfaves, guard)
		else -- try argparse
			local args = strsplit(arg, "-")
			if #args == 2 then
				local lbound = tonumber(args[1])
				local ubound = tonumber(args[2])
				if not (lbound and ubound) then
					CONS_Printf(p, "Got confused when reading this segment (not numbers): \130"..arg)
					return
				end
				if lbound < 1 or ubound > hellcount() or lbound > ubound then
					CONS_Printf(p, "Got confused when reading this segment (pair out of range): \130"..arg)
					return
				end
				for j = lbound, ubound
					table.insert(tfaves, j)
				end
			else
				CONS_Printf(p, "Got confused when reading this segment (wrong args): \130"..arg)
				return
			end
		end
	end
	p.hornmod.faves = tfaves
	CONS_Printf(p, "\131OK! \128Set your favored horns. These will be used when you don't have something else selected.")
end
COM_AddCommand("favehorn", favehorn)
-- helper provided for backcompat
local function horn(p, ...)
	if ... then
		CONS_Printf(p, "* \131(Trying \130sethorn "..table.concat({...}, " ").."\131...)")
		sethorn(p, ...)
		return
	end
	p.hornmod = $ or {}
	local hm = p.hornmod
	-- ugly begins here
	if hm.horn then
		CONS_Printf(p, "Current horn:  "..prettyhornname(hm.horn))
	else
		CONS_Printf(p, "Current horn:  \130None!")
	end
	if hm.selection then
		CONS_Printf(p, "Selected horn: "..prettyhornname(hm.selection))
	else
		CONS_Printf(p, "Selected horn: \130None!")
	end
	if hm.faves then
		local fug = hm.faves
		CONS_Printf(p, "Favored horns: \130"..#fug.." selected")
	else
		CONS_Printf(p, "Favored horns: \130None!")
	end
	CONS_Printf(p, " ")
	CONS_Printf(p, "Commands: \130listhorns\128, \130sethorn\128, \130keephorn\128, \130resethorn\128, \130favehorn\128, \130hornson\128, \130hornsoff\128, \130shutup")
end
COM_AddCommand("horn", horn)
local function keephorn(p, ...)
	p.hornmod = $ or {}
	local hm = p.hornmod
	if hm.horn then
		if hm.horn > hellcount() then
			CONS_Printf(p, "You can't keep a hellhorn. SUPER NICE TRY")
		else
			S_StartSound(nil, _G[hellref(hm.horn).name], p)
			S_StartSound(nil, sfx_hmslct, p)
			CONS_Printf(p, "\131OK!\128 You'll use "..prettyhornname(hm.horn).." from now on.")
			hm.selection = hm.horn
		end
	else
		CONS_Printf(p, "You don't have a horn to keep yet!")
	end
end
COM_AddCommand("keephorn", keephorn)
local function updatevisual(mo, fast)
	if not mo.target then 
		P_RemoveMobj(mo)
		return
	end
	local target = mo.target
	local hm = target.player.hornmod
	local destx = target.x
	local desty = target.y
	local destz = target.z + (40*target.scale)
	if fast then -- early out for interp. this SUCKS
		P_TeleportMove(mo, destx, desty, destz)
		return
	end
	mo.eflags = $ & (~MFE_VERTICALFLIP)
	if target.eflags & MFE_VERTICALFLIP then
		destz = target.z -- FUDGE FACTOR, DON'T CARE. NO IDEA HOW THIS WORKS
		mo.eflags = $|MFE_VERTICALFLIP
	end
	mo.color = target.color
	mo.colorized = true
	mo.destscale = target.scale
	if hm.flash then
		mo.color = SKINCOLOR_YELLOW
		mo.scale = 11*target.scale/10
	end
	mo.scalespeed = target.scale/8
	mo.shake = $ or 0
	if mo.shake > 0 then
		mo.shake = max($ - (mo.shake / 12), 0)
	else
		mo.shake = 0
	end
	-- hellhorns just get angrier as they continue playing
	if hm.horn > #horns and not horn_unleashhell.value then
		mo.shake = max($, 3 * hm.hornduration / 2)
	end
	local shake = min((max(mo.shake, 10) - 10) / 3, 15)
	-- PRNG since visual won't update if a client can't see it, meaning real randomness desyncs
	destx = $ + N_RandomRange(-1 * shake, shake) * target.scale -- shake shake
	desty = $ + N_RandomRange(-1 * shake, shake) * target.scale -- shake shake
	destz = $ + N_RandomRange(-1 * shake, shake) * target.scale + sin(FixedAngle(FixedMul(360*FRACUNIT, FixedDiv((leveltime*12 % 360)*FRACUNIT, 360*FRACUNIT)))) - FRACUNIT/2 -- shake shake
	P_TeleportMove(mo, destx, desty, destz)
end
local function allocatenewhorn(name)
	if not _G[name] then
		freeslot(name)
		sfxinfo[_G[name]].flags = SF_X4AWAYSOUND
	else
		print(name .. " already allocated, distance flag will be wrong!")
	end
end

local function selectRandomHorn(hm)
	hm.horn = P_RandomRange(1, #horns + #hellhorns)
	
	if horn_preferexpansions.value and (not baseonly) then
		while hellref(hm.horn).base
			hm.horn = P_RandomRange(1, #horns + #hellhorns)
		end
	end
end

local function selectHorn(hm)
	hm.horn = hm.selection or P_RandomRange(1, hellcount())
	if hm.faves and (not hm.selection) then
		local fug = hm.faves
		hm.horn = fug[P_RandomRange(1, #fug)]
	else
		if horn_preferexpansions.value and (not hm.selection) and (not baseonly) then
			while hellref(hm.horn).base
				hm.horn = P_RandomRange(1, hellcount())
			end
		end
	end
end

addHook("ThinkFrame", function()
	if leveltime == 0 or #horns == 0 then return end -- leveltime 0 is cursed and runs 3 times.
	for p in players.iterate
		p.hornmod = $ or {}
		-- convenience
		local mo = p.mo
		local ks = p.kartstuff
		local hm = p.hornmod
		if leveltime == 1 or not hm.horn then -- new race!
			-- init
			hm.exploded = false
			hm.postracetimer = 0
			hm.horninput = 0
			hm.hornduration = 0
			hm.sincelasthorn = 0
			hm.horncount = 0
			-- end init
			selectHorn(hm)
			hm.playpenalty = 0
		end
		
		if hm.selection and (leveltime < 7*TICRATE or p.spectator) then
			hm.horn = hm.selection
		end
		
		if not (p.mo and p.mo.valid) then continue end 	-- active players only below this line
		-- input handler
		if p.cmd.buttons & BT_ATTACK then
			hm.horninput = $ + 1
		else
			hm.horninput = 0
		end
		-- remind players that hornmod exists and how to work it, i guess
		if p.exiting or (p.lives == 0) then
			hm.postracetimer = $ + 1
			if hm.postracetimer == 2*TICRATE then
				if hm.horn and (not hm.muted) and  (not (hm.selection or hm.faves)) then
					CONS_Printf(p, "Your horn that race: "..prettyhornname(hm.horn))
				end
				if not hm.tutorial then
					chatprintf(p, "\x83*Use the \130horn\x83 command in console to change horn settings. (This message only displays once.)", true)
					hm.tutorial = true
				end
			end
		end
		-- assign hellhorns in the middle of prerace for that extra feeling of slight panic
		if leveltime == 2*TICRATE then 	
			if ((P_RandomRange(1, 1000) <= horn_hellchance.value) or (mapheaderinfo[gamemap].menuflags % 2 >= 1))
		and not hm.selection and not horn_unleashhell.value and not horn_truerandom.value and not hm.muted then
				S_StartSound(nil, sfx_hmhell, p)
				chatprintf(p, "\x83*A shadow passes over your item button...")
				p.hornmod.horn = #horns + P_RandomRange(1, #hellhorns)
				if horn_preferexpansions.value and (not hellbaseonly) then
					while hellref(p.hornmod.horn).base do
						p.hornmod.horn = #horns + P_RandomRange(1, #hellhorns)
					end
				end
			end
		end
		local hornsound = _G[hellref(hm.horn).name] -- resolve the horn sound for use later down the line
		local hornvolume = 255
		if not (hm.origin and hm.origin.valid and hm.visual and hm.visual.valid and hm.visual.target and hm.visual.target.valid) then -- need to make sure fresh respawns have objects set up
			dprint("Spawning origin for", p.name)
			hm.origin = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
			hm.origin.state = S_INVISIBLE
			hm.origin.tics = -1
			hm.origin.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
			hm.visual = P_SpawnMobj(mo.x, mo.y, mo.z, MT_HAHALOUD)
			hm.visual.target = mo
		else
			if p.exiting then
				hm.horncount = 0
				if p.kartstuff[k_position] != 1 then hornvolume = 100 end
			end
			if p.hornmod.muffled then hornvolume = 50 end
			-- let's allow shutup'd players to still communicate, but in a less annoying way
			if hm.muffled then
				hm.visual.flags2 = $ | MF2_SHADOW
			else
				hm.visual.flags2 = $ & (~MF2_SHADOW)
			end
			P_TeleportMove(hm.origin, mo.x, mo.y, mo.z)
			-- draw only if the sound is actually playing, meaning no visuals while muted
			-- (this also affects players with -noaudio)
			updatevisual(hm.visual, true) -- minimal position update to prevent interp fuckery, MAYBE BAD
			if S_SoundPlaying(hm.origin, hornsound) then
				hm.visual.flags2 = $ & (~MF2_DONTDRAW)
				hm.hornduration = $ + 1
				hm.playpenalty = $ + 3
				updatevisual(hm.visual)
			else
				hm.visual.flags2 = $ | MF2_DONTDRAW
				hm.hornduration = 0
				hm.playpenalty = max(0, $ - 1)
			end
		end	
		hm.sincelasthorn = $ + 1
		-- are we pressing horn?
		if hm.horninput == 1 then
			-- okay, are we able to horn?
			if (p.exiting) or (p.playerstate == PST_LIVE
			and not hm.lastroulette and not hm.lastitem
			and not hm.lastheld and not hm.lasteggman
			and not hm.lastsneaker and not ks[k_eggmanexplode]
			and not hm.muted) then
				if horn_truerandom.value then
					selectRandomHorn(hm)
					hornsound = _G[hellref(hm.horn).name]
				end
				
				hm.flash = 2 -- yellow flash for a little extra impact
				-- should we be doing spam calculations? if you're under a powerup or in 1v1, you're immune.
				if horn_antispam.value then
					if leveltime > starttime
					and not (ks[k_growshrinktimer] > 0)
					and (not ks[k_invincibilitytimer])
					and (playercount() > 2) then
						-- a small amount of uncertainty makes the spam warning more forboding
						hm.horncount = $ + 1 + (leveltime % 2)
						-- spamming horns slowly means more total time spent playing noises
						-- this is basically a discount on rapid mashing, since it's not actually that disruptive
						if hm.sincelasthorn >= TICRATE/2 then
							hm.horncount = $ + 2
						end
						hm.sincelasthorn = 0
						hm.warnanim = 10 -- pulses the spam warning text
					end
				end
				-- step 2: play the rest of the fucking horn
				if not muted and (leveltime > starttime or p == consoleplayer or horn_ignorecountdown.value) then
					S_StopSound(hm.origin)
					if p == consoleplayer then
						S_StartSoundAtVolume(hm.origin, hornsound, 255) -- sneaky...always hear your own horns at max volume
					else
						S_StartSoundAtVolume(hm.origin, hornsound, hornvolume)
					end
				end
				-- and a little bit of extra sauce for the visual
				if hm.visual and hm.visual.valid then
					hm.visual.shake = $ or 0
					hm.visual.shake = $ + 10
				end
			end
		end
		if horn_antispam.value then
			-- warnstate tracks what level of warning the player knows they're under
			-- at warnstate 3, you die!
			hm.warnstate = $ or 0
			hm.warnanim = $ or 0
			hm.warnanim = max($-1, 0)
			hm.horncount = $ or 0
			-- reset if they haven't touched the horn for a few seconds.
			if hm.sincelasthorn > 5*TICRATE and hm.warnstate != 3 then
				hm.horncount = 0
				hm.warnstate = 0
			end
			-- cues for various levels of warnstate
			if hm.horncount > 39 and hm.warnstate == 2 then
				hm.warnanim = 10
				hm.warnstate = 3
			elseif hm.horncount > 26 and hm.warnstate == 1 then
				hm.warnanim = 10
				hm.warnstate = 2
				S_StartSoundAtVolume(nil, sfx_hmdang, 255, p)
				S_StartSoundAtVolume(nil, sfx_s3k50, 160, p)
			elseif hm.horncount > 13 and (not hm.warnstate) then
				hm.warnstate = 1
				hm.warnanim = 10
				S_StartSoundAtVolume(nil, sfx_hmwarn, 255, p)
				S_StartSoundAtVolume(nil, sfx_s3kb2, 160, p)
			end
			-- okay, you've been too loud, time to die
			-- we gate this behind no spinout and grounded—no using it to cheese
			-- could check against spbposition as well, but handling that case is kinda wacky...
			-- ...and if you can time a horn explosion to avoid the SPB, IMO you've kinda earned it
			if hm.warnstate == 3 and not ks[k_spinouttimer] and P_IsObjectOnGround(mo) then
				S_StartSound(nil, sfx_cdfm73, p)
				-- remove any perverse incentive to explode constantly for attention.
				if not hm.exploded then
					S_StartSound(p.mo, sfx_kc3b)
					K_SpawnMineExplosion(mo, p.skincolor)
				end
				if (hitfeed) then HF_SendHitMessage({{nil, nil}, {nil, nil}, nil}, {{p.name, p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}, "K_HORNHF", p.skincolor) end
				P_DamageMobj(mo, nil, nil, 10000)
				S_StopSound(hm.origin)
				S_StopMusic(p)
				hm.exploded = true
				hm.horncount = 0
				hm.warnstate = 0
			end
		end
		hm.flash = $ or 0
		hm.flash = max($ - 1, 0)
		 -- update next frame's item information
		hm.lastitem = ks[k_itemtype]
        hm.lastroulette = ks[k_itemroulette]
		hm.lastheld = ks[k_itemheld]
		hm.lasteggman = ks[k_eggmanheld]
		hm.lastsneaker = ks[k_rocketsneakertimer]
	end
end)
rawset(_G, "HORNMOD_AddHorns", function(...) -- expects same format as the horn table up top
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		allocatenewhorn(v.name)
		table.insert(horns, v)
		print("HORNMOD: Added " .. v.name)
		-- oh yeah, let's make sure the script knows preferexpansions will work
		if not v.base then baseonly = false end
	end
end)
rawset(_G, "HORNMOD_AddHellHorns", function(...)
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		v.hell = true
		allocatenewhorn(v.name)
		table.insert(hellhorns, v)
		print("HORNMOD: Added " .. v.name)
		if not v.base then hellbaseonly = false end
	end
end)
hud.add(function(v, p, c)
	if not p.hornmod then return end
	local hm = p.hornmod
	if hm.warnstate then
		local warnings = {"\130EASE OFF THE HORN", "\133I ASKED POLITELY", "\133TIME TO DIE"}
		local flags = 0
		-- pulse when player does bad things
		if not (hm.warnanim % 2) then flags = V_50TRANS end
		v.drawString(160, 30, warnings[hm.warnstate], flags, "center")
	end
end)